# Forms.pm (HCT::Output::Forms) - formatting of output.
#
# Copyright 2008, 2009
# Slade Maurer
#
# This file is part of HCT, the Hardware Complexity Tool

package HCT::Output::Forms;

our $VERSION = '1.0.1';

use strict;

sub new ()
{
	my $inv = shift;
	my $class = ref($inv) || $inv;
	my $self = {
		forms	=> { },
		options	=> [ ],
		@_
	};
	bless $self, $class;
	return $self;
}

sub set_options
{
	my $self = shift;
	
	unless (scalar(@_) > 0) {
		# XXX: print something
		return ;
	}

	$self->{'options'} = [ @_ ];
}

sub options
{
	my $self = shift;
	(defined $self->{'options'}->[0]) ? ($self->{'options'}->[0]) : (undef);
}

sub set
{
	my $self = shift;
	$self->{'forms'} = shift;
}

sub clear
{
	$^A = ''
}

sub fill
{
	shift;
	write();
}

sub get
{
	my $self = shift;
	my $options = [shift];
	   $options = $self->{'options'}
	   	if !defined $options->[0];
	my $form = $self->{'forms'};

	# FIXME: if items is not setted?

	sub __goto_point
	{
		return	(ref($_[0]) eq 'HASH')	?	($_[0]->{$_[1]})	:
				(ref($_[0]) eq 'ARRAY')	?	($_[0]->[$_[1]])	:
		undef;
	}

	if (!defined ($options->[0])) {
		
	}

	elsif (ref($options->[0]) eq 'SCALAR') {
		$form = $$options->[0];
	} 

	elsif (ref($options->[0]) eq 'HASH') {
		for (1 .. (scalar(@$options)-1)) {
			my $point = $options->[0]->{ $options->[$_] };
			$form = __goto_point($form, $point);
			return undef unless defined $form;
		}

	}

	elsif ( ref($options->[0]) eq "ARRAY" ) {
		foreach my $point ( @$options ) {
			$form = __goto_point($form, $point);
			return undef unless defined $form;
		}
	}

	return $form;
}

sub put
{
	my $self = shift;

	$self->clear;

	eval "format STDOUT = \n" . $self->get . "\n.\n";
	
	if ($@) {
		print "format STDOUT = \n" . $self->get . "\n.\n";		
		print $@;
		exit(0);
	}
}

1;

__END__

%FORMS = ( ... );

* How to get handler and load my forms?

	$outform = Toolkit::API::Output::Form->new( forms => \%FORMS );

	or

	$outform = Toolkit::API::Output::Form->new( );
	$outform->set( \%FORMS );

* How to set an options for the forms?

	@options = (point1, point2, ..., pointN);	# or can be just:
	$outform->set_options(\@options);			# $outform->set_options([point1, point2, ..., pointN]);

	or
	
	%options = (key1 => point1, key2 => point2, ..., keyN => pointN);
	$outform->set_options(\%options, key1, key2, ..., keyN); # the order of keys is very important

* How to print some part of form?

	print $outform->get( [<path>] );

	or if path was setted
	
	print $outform->get;

* How to put my form and fill it?

	$outform->put;
	$outform->fill( value1,	value2,	...	valueN );

* How to clear the form?

	$outform->clear();

HACKS:

	How to handle path:
	
	my @path = (point1, point2, ..., pointN);
	$outform->path( \@path );
	$path[1] = point3; # now path has view: point1, point3, point3, ..., pointN	

